# 서문

## 요구사항

디스코도는 **Python 3.7+** 에서 동작합니다.

더 이른 버전들은 작동하지 않을 수 있습니다.

## 설치

이 라이브러리는 [**PyPI**](https://pypi.org/project/discodo/)에서 설치할 수 있습니다:

```sh
python3 -m pip install --upgrade discodo
```

리눅스 환경에서는, 일부 라이브러리가 더 필요합니다:

- python3-dev
- libopus-dev
- libnacl-dev

## 실행

추가적인 옵션은 `--help` 플래그로 확인할 수 있습니다.

```sh
python3 -m discodo [-h] [--config CONFIG] [--host HOST] [--port PORT] [--auth AUTH] [--ws-interval WS_INTERVAL]
               [--ws-timeout WS_TIMEOUT] [--ip IP] [--exclude-ip EXCLUDE_IP] [--default-volume DEFAULT_VOLUME]
               [--default-crossfade DEFAULT_CROSSFADE] [--default-gapless DEFAULT_GAPLESS]
               [--default-autoplay DEFAULT_AUTOPLAY] [--bufferlimit BUFFERLIMIT] [--preload PRELOAD]
               [--timeout TIMEOUT] [--verbose]
```

## 설정

```
선택 인자:
  -h, --help            이 도움말 메세지를 띄웁니다
  --version             디스코도의 버전을 띄웁니다
  --config CONFIG       설정 JSON 파일 경로 (기본: None)

서버 설정:
  --host HOST, -H HOST  서버가 바인딩할 호스트 이름 (기본: 0.0.0.0)
  --port PORT, -P PORT  서버가 바인딩할 포트 (기본: 8000)
  --auth AUTH, -A AUTH  서버의 비밀번호 (기본: hellodiscodo)
  --ws-interval WS_INTERVAL
                        디스코도 서버와 클라이언트사이의 Heartbeat 간격 (기본: 15)
  --ws-timeout WS_TIMEOUT
                        Heartbeat 답장을 기다릴 시간 (기본: 60)

네트워크 설정:
  --ip IP               추출에 사용할 IP 블럭
  --exclude-ip EXCLUDE_IP
                        추출에 사용하지 않을 IP

플레이어 설정:
  --default-volume DEFAULT_VOLUME
                        플레이어의 기본 볼륨 (기본: 100)
  --default-crossfade DEFAULT_CROSSFADE
                        플레이어의 기본 크로스페이드 시간 (기본: 10.0)
  --default-autoplay DEFAULT_AUTOPLAY
                        플레이어의 기본 추천영상 자동재생 여부 (기본: True)
  --bufferlimit BUFFERLIMIT
                        버퍼에 저장할 파일의 길이 (기본: 5)
  --preload PRELOAD     다음곡을 미리 로드할 시간 (기본: 10)
  --timeout TIMEOUT     디스코드 음성 서버 연결 대기시간 (기본: 300)

로깅 설정:
  --verbose, -v         디버그 모드를 활성화합니다.
```

### 설정파일

`--config` 플래그로 `JSON` 파일 경로를 전달해야 합니다.

```json
{
    "HOST": "0.0.0.0",
    "PORT": 8000,
    "PASSWORD": "hellodiscodo",
    "HANDSHAKE_INTERVAL": 15,
    "HANDSHAKE_TIMEOUT": 60,
    "IPBLOCKS": [],
    "EXCLUDEIPS": [],
    "DEFAULT_AUTOPLAY": true,
    "DEFAULT_VOLUME": 1,
    "DEFAULT_CROSSFADE": 10,
    "DEFAULT_GAPLESS": false,
    "BUFFERLIMIT": 5,
    "PRELOAD_TIME": 10,
    "VCTIMEOUT": 300,
    "ENABLED_EXT_RESOLVER": [
        "melon",
        "spotify"
    ],
    "SPOTIFY_ID": null,
    "SPOTIFY_SECRET": null
}
```
